---
title: Beacon API
slug: Web/API/Beacon_API
tags:
  - Guide
  - Overview
  - Web Performance
  - user behavior tracker
  - user tracker
---
<div>{{DefaultAPISidebar("Beacon")}}</div>

<p>The <strong><code>Beacon</code></strong> interface is used to schedule an asynchronous and non-blocking request to a web server. Beacon requests use the HTTP POST method and requests typically do not require a response. Requests are guaranteed to be initiated before a page is unloaded and they are run to completion, without requiring a blocking request (for example {{domxref("XMLHttpRequest")}}).</p>

<div class="notecard note">
<p><strong>Note:</strong> This API is <em>not available</em> in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a> (not exposed via {{domxref("WorkerNavigator")}}).</p>
</div>

<p>Example use cases of the Beacon API are logging activity and sending analytics data to the server.</p>

<p>Example code of the interfaces described in this document is included in <em><a href="/en-US/docs/Web/API/Beacon_API/Using_the_Beacon_API">Using the Beacon API</a></em>.</p>

<h2 id="Why_use_Beacon">Why use Beacon?</h2>

<p>The <code>Beacon</code> interface addresses the needs of analytics and diagnostics code that typically attempts to send data to a web server before unloading the document. Sending the data any sooner may result in a missed opportunity to gather data. However, ensuring that the data is sent during the unloading of a document is something that has traditionally been difficult for developers.</p>

<p>User agents will typically ignore asynchronous {{domxref("XMLHttpRequest","XMLHttpRequests")}} made in an unload handler. To solve this problem, analytics and diagnostics code will typically make a synchronous {{domxref("XMLHttpRequest")}} in an {{event("unload")}} or {{event("beforeunload")}} handler to submit the data. The synchronous {{domxref("XMLHttpRequest")}} forces the browser to delay unloading the document, and makes the next navigation appear to be slower. There is nothing the next page can do to avoid this perception of poor page load performance.</p>

<p>There are other techniques used to ensure that data is submitted. One such technique is to delay the unload to submit data by creating an Image element and setting its <code>src</code> attribute within the unload handler. As most user agents will delay the unload to complete the pending image load, data can be submitted during the unload. Another technique is to create a no-op loop for several seconds within the unload handler to delay the unload and submit data to a server.</p>

<p>Not only do these techniques represent poor coding patterns, some of them are unreliable and result in the perception of poor page load performance for the next navigation. The Beacon API provides a standard way to address these issues.</p>

<h2 id="Global_context">Global context</h2>

<p>The Beacon API's {{domxref("Navigator.sendBeacon()")}} method is used to send a <em>beacon</em> of data to the server in the <em>global browsing context</em>. The method takes two arguments, the URL and the data to send in the request. The data argument is optional and its type may be an {{domxref("ArrayBufferView")}}, {{domxref("Blob")}}, {{domxref("DOMString")}}, or {{domxref("FormData")}}. If the browser successfully queues the request for delivery, the method returns "<code>true</code>" and returns "<code>false</code>" otherwise.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>The {{domxref("Navigator.sendBeacon","Navigator.sendBeacon()","Browser_compatibility")}} table indicates that method has relatively broad implementation.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WorkerGlobalScope")}}</li>
 <li><a href="https://w3c.github.io/beacon/">Beacon standard</a></li>
 <li><a href="http://caniuse.com/#search=beacon">Beacon CanIUse data</a></li>
 <li><a href="https://ehsanakhgari.org/blog/2015-04-08/intercepting-beacons-through-service-workers">Intercepting beacons through service workers</a>; Ehsan Akhgari; 2015-Apr-08</li>
 <li><a href="https://webkit.org/blog/8821/link-click-analytics-and-privacy/">https://webkit.org/blog/8821/link-click-analytics-and-privacy/</a></li>
</ul>
